include(/runtime/include/qtango5/qtango.pri)

message("The detected Qt version is \"$${QT_VERSION}\".")
message("This application requires at least Qt 4.8 to run smoothly")

contains(QT_VERSION,  "^4\\.[0-7]") {
	message("It's better to build this application with a Qt >= 4.8")
	message("The detected Qt version is \"$${QT_VERSION}\".")
	message("If you want to build the application with a previous version, remove")
	message("this check in spectrometer.pro. Beware: the application will run much slower!")
	error("Use at least Qt 4.8")
}

DEFINES -= QT_NO_DEBUG_OUTPUT

QT += opengl widgets

CONFIG += debug

unix:INCLUDEPATH+= /runtime/include/qgraphicsplot

QMAKE_CXXFLAGS += -O3

RESOURCES = spectrometer.qrc

SOURCES += src/spectrometer.cpp \
           src/main.cpp \
    src/image.cpp \
    src/imagereadingthread.cpp \
    src/imagereadevent.cpp \
    src/fileio.cpp \
    src/imagemouseeventinterface.cpp \
    src/usage.cpp \
    src/imagewidgetbase.cpp \
    src/imagegl.cpp \
    src/profiles/profiles.cpp \
    src/spectrometer_colormap.cpp \
    src/profiles/circulardatamanager.cpp \
    src/infodialog.cpp
HEADERS += src/spectrometer.h \
    src/image.h \
    src/imagereadingthread.h \
    src/imagereadevent.h \
    src/fileio.h \
    src/imagemouseeventinterface.h \
    src/usage.h \
    src/imagewidgetbase.h \
    src/imagegl.h \
    src/profiles/profiles.h \
    src/profiles/circulardatamanager.h \
    src/infodialog.h

FORMS    = src/spectrometer.ui src/profiles/profiles.ui

TARGET   = bin/spectrometer


LIBS +=  -lQGraphicsPlot
