#include "fileio.h"
#include <QFile>
#include <QMessageBox>
#include <QFileDialog>
#include <QImage>

FileIO::FileIO()
{
}

std::vector<unsigned char> FileIO::getImageFromFile()
{
    std::vector<unsigned char> imageArray;
    QFile file("in.txt");
    int i;

    if (!file.open(QIODevice::ReadOnly | QIODevice::Text))
    {
        QMessageBox::critical(0, "Error opening file in read only mode",
                              QString("Error opening %1 for reading:\n%2").arg("in.txt")
                              .arg(file.errorString()));
    }
    else
    {
        while (!file.atEnd())
        {
            sscanf(file.readLine().data(), "%d", &i);
            imageArray.push_back((unsigned char) i);
        }
    }
    return imageArray;
}

void  FileIO::snapshot(const QImage& image, const QString& fileNam)
{
    QString fileName = QFileDialog::getSaveFileName(0, "Save File", fileNam);
    if (fileName != "")
    {
        fileName.append(".tiff");
        printf("saving an image of %d x %d\n", image.width(), image.height());
        if (image.save(fileName, "TIFF", 100))
        {
            QFileInfo fi(fileName);
            QMessageBox::information(0, "Snapshot saved",
                                  QString("The image snapshot (TIFF) was saved in %1").arg(fi.absoluteFilePath()));
        }
        else
            QMessageBox::critical(0, "Failed to save file", QString("Failed to save file \"%1\"")
                                  .arg(fileName));
    }
}

void FileIO::save(const unsigned char *image, int maxX, int maxY, const QString& fileNam)
{
    QString fileName = QFileDialog::getSaveFileName(0, "Save File", fileNam);
    if (fileName != "")
    {
        fileName.append(".data");
        QFile data(fileName);
        if (!data.open(QIODevice::WriteOnly | QIODevice::Text))
        {
            QMessageBox::critical(0, "Error opening file in read only mode",
                                  QString("Error opening %1 for reading:\n%2").arg(fileName)
                                  .arg(data.errorString()));
        }
        else
        {
            int x, y, index = 0;
            QString line("");
            for (x = 0; x < maxX; x++) {
                line.clear();
                for (y = 0; y < maxY; y++) {
                    line.append(QString("%1,").arg(image[index++], 3));
                }
                line.replace(line.size()-1, 1, "\n");
                data.write(line.toAscii().data());
            }
            data.flush();
            data.close();
            QFileInfo fi(data);
            QMessageBox::information(0, "Image data saved",
                                     QString("The image data was saved in %1").arg(fi.absoluteFilePath()));
        }
    }
}









