#include "image.h"
#include <QtDebug>
Image::Image(QWidget *parent) :
    QWidget(parent),
    ImageWidgetBase(this, false)
{

}

void Image::setErrorImageEnabled(bool en)
{
    ImageWidgetBase::setErrorImageEnabled(en);
    update();
}

void Image::setImage(const QImage& image)
{
    mImage = image;
    update();
}

void Image::mousePressEvent(QMouseEvent *ev)
{
    mousePress(ev);
}

void Image::mouseMoveEvent(QMouseEvent *ev)
{
    mouseMove(ev);
}

void Image::mouseReleaseEvent(QMouseEvent *ev)
{
    mouseRelease(ev);
}


void Image::paintEvent(QPaintEvent *e)
{
    paint(e, this);
}
