#include "imagegl.h"
#include <QtDebug>

ImageGL::ImageGL(QWidget *parent) :
    QGLWidget(parent),
    ImageWidgetBase(this, true)
{

}

void ImageGL::setErrorImageEnabled(bool en)
{
    ImageWidgetBase::setErrorImageEnabled(en);
    update();
}

void ImageGL::setImage(const QImage& image)
{
    mImage = image;
    update();
}

void ImageGL::mousePressEvent(QMouseEvent *ev)
{
    mousePress(ev);
}

void ImageGL::mouseMoveEvent(QMouseEvent *ev)
{
    mouseMove(ev);
}

void ImageGL::mouseReleaseEvent(QMouseEvent *ev)
{
    mouseRelease(ev);
}


void ImageGL::paintEvent(QPaintEvent *e)
{
    paint(e, this);
}
