#ifndef IMAGEREADINGTHREAD_H
#define IMAGEREADINGTHREAD_H

#include <QThread>
#include <tango.h>
#include <QReadWriteLock>

class QTimer;

class ImageReadingThread : public QThread
{
    Q_OBJECT
public:
    explicit ImageReadingThread(QObject *parent, const QString& devname);

    virtual ~ImageReadingThread();

    void getImage();
    
signals:
    void exitLoop();

    void processRequest();

    void changePeriod();

public slots:
    void setPeriod(int period);

    void startPolling();

    void stopPolling();

    void setImageDepth(int dpt);

protected:
    void run();

protected slots:

    void read();

    void applyPeriodChange();

private:
    QTimer *mProcessTimer;

    int mPeriod, mImageDepth;

    QString mDevname, mAttName;

    Tango::DeviceProxy *mDevice;

    QReadWriteLock mRWLock;
};

#endif // IMAGEREADINGTHREAD_H
