/***************************************************************************
 *   $Id: main.cpp,v 1.2 2012-08-30 12:20:08 giacomo Exp $
 *                                                                         *
 *   Copyright (C) 2009 by Fabio Asnicar  fabio.asnicar@elettra.trieste.it *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <TApplication>
#include "spectrometer.h"
#include <tutil.h>
#include <X11/Xlib.h>
#include <QX11Info>
#include <TSplashScreen>
#include <elettracolors.h>

#define CVSVERSION "$Name:  $"

int main(int argc, char ** argv) {
    const char *cvs_version = CVSVERSION;
    TApplication a(argc, argv);
    a.setPalette(EPalette("fermi"));
    a.setApplicationVersion(cvs_version);
    a.setApplicationName("Spectrometer");
    a.setProperty("author", "Giacomo Strangolino");

    TUtil::instance()->setLoggingTarget(argv[0]);
    TSplashScreen splash;

    Spectrometer mw;
    if (argc > 1) {
        mw.setWindowTitle(TApplication::instance()->arguments()[1].split('/').last());
    } else {
        mw.setWindowTitle("spectrometer");
    }
    mw.show();
    splash.finish(&mw);

    /* register to window manager */
    Display *disp = QX11Info::display();
    Window root_win = (Window) mw.winId();
    XSetCommand(disp, root_win, TApplication::argv(), TApplication::argc());

    return a.exec();
}
