#include "spectrometer.h"

void Spectrometer::generateColorMap() {
    int i;

    // palette 1
    float delta = 1.0/306;
    // float base  = 5.0/6;
    float r;
    for (i=0; i<256; i++) {
        r = (float)i*delta;
        paletteBW.append(QColor::fromHsv(0,0,i).rgb());
        // paletteColor1.append(QColor::fromHsvF((base-r),1,1).rgb()); // not used
    }

    // palette 2
    float deltaA = 255.0/31;
    float deltaB = 255.0/62;
    float deltaC = 255.0/37;
    //     int indexTmp = 0;
    for (i=0; i<32; i++) {
        paletteColor2.append(QColor( round((float)i*deltaA), 0, round((float)i*deltaA)).rgb());  // (r,g,b)
        //         // qDebug() << indexTmp << "," << i << "," << round((float)i*deltaA) << "," << 0 << "," << round((float)i*deltaA);
        //         indexTmp++;
    }
    for (i=30; i>=0; i--) {
        paletteColor2.append(QColor( round(i*deltaA), 0, 255).rgb());  // (r,g,b)
        //         // qDebug() << indexTmp << "," << i << "," << round((float)i*deltaA) << "," << 0 << "," << 255;
        //         indexTmp++;
    }
    for (i=1; i<32; i++) {
        paletteColor2.append(QColor( 0, round((float)i*deltaA), 255).rgb());  // (r,g,b)
        //         // qDebug() << indexTmp << "," << i << "," << 0 << "," << round((float)i*deltaA) << "," << 255;
        //         indexTmp++;
    }
    for (i=30; i>=0; i--) {
        paletteColor2.append(QColor(0, 255, round((float)i*deltaA)).rgb());  // (r,g,b)
        //         // qDebug() << indexTmp << "," << i << "," << 0 << "," << 255 << "," << round((float)i*deltaA);
        //         indexTmp++;
    }
    for (i=1; i<32; i++) {
        paletteColor2.append(QColor( round((float)i*deltaA), 255, 0).rgb());  // (r,g,b)
        //         // qDebug() << indexTmp << "," << i << "," << round((float)i*deltaA) << "," << 255 << "," << 0;
        //         indexTmp++;
    }
    for (i=61; i>=0; i--) {
        paletteColor2.append(QColor(255, round((float)i*deltaB), 0).rgb());  // (r,g,b)
        //         // qDebug() << indexTmp << "," << i << "," << 255 << "," << round((float)i*deltaB)<< "," << 0 ;
        //         indexTmp++;
    }
    for (i=1; i<38; i++) {
        paletteColor2.append(QColor(255, round((float)i*deltaC), round((float)i*deltaC)).rgb());  // (r,g,b)
        //         // qDebug() << indexTmp << "," << i << "," << 255 << "," << round((float)i*deltaC) << "," << round((float)i*deltaC);
        //         indexTmp++;
    }
    paletteColor2.append(QColor(255, 255, 255).rgb());  // (r,g,b)
    //     // qDebug() << indexTmp << "," << "x" << "," << 255 << "," << 255 << "," << 255;

    // palette HOT
    deltaA = 1.0/96;
    deltaB = 1.0/64;
    for (i=1; i<96; i++) {
        paletteColorHot.append(QColor::fromRgbF( (float)i*deltaA, 0.0, 0.0 ).rgb());
    }
    paletteColorHot.append(QColor::fromRgbF( 1.0, 0.0, 0.0 ).rgb());
    for (i=1; i<96; i++) {
        paletteColorHot.append(QColor::fromRgbF( 1.0, (float)i*deltaA, 0.0 ).rgb());
    }
    paletteColorHot.append(QColor::fromRgbF( 1.0, 1.0, 0.0 ).rgb());
    for (i=1; i<65; i++) {
        paletteColorHot.append(QColor::fromRgbF( 1.0, 1.0, (float)i*deltaB ).rgb());
    }

    // palette JET
    for (i=33; i<65; i++) {
        paletteColorJet.append(QColor::fromRgbF( 0.0, 0.0, (float)i*deltaB ).rgb());
    }
    for (i=1; i<65; i++) {
        paletteColorJet.append(QColor::fromRgbF( 0.0, (float)i*deltaB, 1.0 ).rgb());
    }
    for (i=1; i<65; i++) {
        paletteColorJet.append(QColor::fromRgbF( (float)i*deltaB, 1.0,  1.0-(float)i*deltaB ).rgb());
    }
    for (i=1; i<65; i++) {
        paletteColorJet.append(QColor::fromRgbF( 1.0, 1.0-(float)i*deltaB, 0.0 ).rgb());
    }
    for (i=1; i<33; i++) {
        paletteColorJet.append(QColor::fromRgbF( 1.0-(float)i*deltaB, 0.0, 0.0 ).rgb());
    }
}

void Spectrometer::setColorMap(bool v) {
    // qDebug() << "Spectrometer::setColorMap  v=" << v;
    if (v) {
        if (ui.bw_radioButton->isChecked()) {
            colorMap = paletteBW;
        } else if (ui.c_radioButton->isChecked()) {
            colorMap = paletteColor2;
        } else if (ui.jet_radioButton->isChecked()) {
            colorMap = paletteColorJet;
        } else if (ui.hot_radioButton->isChecked()) {
            colorMap = paletteColorHot;
        }
    }
}

