#include "usage.h"
#include <QTextBrowser>
#include <QVBoxLayout>
#include <QCoreApplication>
#include <QPushButton>

Usage::Usage(QWidget *parent) :
    QDialog(parent)
{
    QVBoxLayout lo(this);
    QTextBrowser te(this);
    QPushButton pb(this);
    pb.setText("I see...");
    lo.addWidget(&te);
    lo.addWidget(&pb);
    te.setOpenExternalLinks(true);
    connect(&pb, SIGNAL(clicked()), this, SLOT(close()));
    QString message;
    message +=  "<h3>Spectrometer Usage</h3>\n" ;
    message +=  QString("<p><em>%1 ccd_pesp pesp-pesp ccd_pesp p_pesp r_pesp pespstore [OPTION]</em></p>").arg(qApp->arguments().first());                              ;
    message +=  "<h4>OPTION:</h4>\n"                                                           ;
    message +=  "<ul>\n";
    message +=  "<li>    <em>--refresh=t</em> "                                                    ;
    message +=  "        set the number of ms between image refreshing (default=100)</li>\n"  ;
    message += "<li><em>--help</em> display this help and exit.</li>";
    message += "</ul>\n";
    message += "<h3>Example</h3>";
    message += QString("<cite>%1 pos/pesp/ccd-pesp_pos.01 pos/pesp/pesp-pesp_pos.01 "
                       " pos/pesp/ccd-pesp_pos.01  pos/movers/p_pesp_pos.01 pos/movers/r_pesp_pos.01 pos/pespstore/ccd-pesp_pos.01 </cite>")
            .arg(qApp->arguments().first());
    message += "<h3>Support</h3>";
    message += "<ul><li><a href=\"mailto:giacomo.strangolino@elettra.trieste.it\">giacomo.strangolino@elettra.trieste.it</a></li>";
    message += "<li><a href=\"mailto:alessandro.abrami@elettra.trieste.it\">alessandro.abrami@elettra.trieste.it</a></li>";
    message += "</ul>";
    te.setHtml(message);
    resize(390, 350);
    exec();
}
